#include <avr/io.h>
#include <util/delay.h>
#include <inttypes.h>
#include "lcd.h"
#include "lcd_bl.h"
#include "myutils.h"


#define uint unsigned int

//LCD Backlight i/o configuration
#define LCDBL_PORT 	PORTB
#define LCDBL_DDR	DDRB
#define	LCDBL_PIN	PB1

//Output relay i/o configuration
#define PUMP_PORT 	PORTC
#define PUMP_DDR 	DDRC
#define PUMP_PIN 	PC0
#define FORS_ONE_PORT	PORTC
#define FORS_ONE_DDR	DDRC
#define FORS_ONE_PIN	PC1
#define FORS_TWO_PORT	PORTC
#define FORS_TWO_DDR	DDRC
#define FORS_TWO_PIN	PC2
#define FORS_THRE_PORT	PORTC
#define FORS_THRE_DDR	DDRC
#define FORS_THRE_PIN	PC3
#define FORS_FOUR_PORT	PORTC
#define FORS_FOUR_DDR	DDRC
#define FORS_FOUR_PIN	PC4
#define DRAIN_VALVE_PORT	PORTC
#define DRAIN_VALVE_DDR		DDRC
#define	DRAIN_VALVE_PIN		PC5
//Simple Delay Function
void Wait(uint8_t n);

//Relay Control Functions
void PumpOn(void);
void PumpOff(void);
void ForsOneOn(void);
void ForsTwoOn(void);
void ForsOneOff(void);
void ForsTwoOff(void);
void ForsThreOn(void);
void ForsFourOn(void);
void ForsThreOff(void);
void ForsFourOff(void);
void AllForsOn(void);
void AllForsOff(void);
void ValveOn(void);
void ValveOff(void);

//System Functions
void SystemInit(void);
uint rep,time;

int main(void)
{

		SystemInit();
		while(1)
		{
				LCDClear();
				LCDWriteString(" Press Mode Key");
				//     1
					LCDBlOn();
					LCDClear();
					LCDWriteStringXY(0,0,"     Mode 1");
					LCDWriteStringXY(1,0,"processing. . .");
					PumpOn();
					Wait(5);
					while(rep--){
					time=100;
					AllForsOn();
					while(time--){;}
					time=200;
					AllForsOff();
					while(time--){;}
					PumpOff();
					Wait(30);
					}
					ValveOn();
					Wait(20);
					ValveOff();
					Wait(10);
					LCDBlOff();
					
					
				//     2
					LCDBlOn();
					LCDClear();
					LCDWriteStringXY(0,0,"     Mode 2");
					LCDWriteStringXY(1,0,"processing. . .");
					PumpOn();
					Wait(5);
					while(rep--){
					time=500;
					AllForsOn();
					while(time--){;}
					time=700;
					AllForsOff();
					while(time--){;}
					PumpOff();
					Wait(30);
					}
					ValveOn();
					Wait(20);
					ValveOff();
					Wait(10);
					LCDBlOff();
				//     3
					LCDClear();
					LCDBlOn();
					LCDWriteStringXY(0,0,"     Mode 3");
					LCDWriteStringXY(1,0,"processing. . .");;
					PumpOn();
					Wait(5);
					while(rep--){
					time=400;
					AllForsOn();
					while(time--){;}
					time=400;
					AllForsOff();
					while(time--){;}
					PumpOff();
					Wait(30);
					}
					ValveOn();
					Wait(20);
					ValveOff();
					Wait(10);
					LCDBlOff();
				//     4
					LCDClear();
					LCDBlOn();
					LCDWriteStringXY(0,0,"     Mode 4");
					LCDWriteStringXY(1,0,"processing. . .");;
					PumpOn();
					Wait(5);
   					while(rep--){
					time=1000;
					AllForsOn();
					while(time--){;}
					time=1000;
					AllForsOff();
					while(time--){;}
					PumpOff();
					Wait(30);
					}
					ValveOn();
					Wait(20);
					ValveOff();
					Wait(10);
					LCDBlOff();
				}

				
				
		
}

void SystemInit(void)
{
	DRAIN_VALVE_DDR|=(1<<DRAIN_VALVE_PIN);
	LCDBL_DDR|=(1<<LCDBL_PIN);
	PUMP_DDR|=(1<<PUMP_PIN);
	FORS_ONE_DDR|=(1<<FORS_ONE_PIN);
	FORS_TWO_DDR|=(1<<FORS_TWO_PIN);
	FORS_THRE_DDR|=(1<<FORS_THRE_PIN);
	FORS_FOUR_DDR|=(1<<FORS_FOUR_PIN);
	_delay_loop_2(0);
	LCDInit(LS_NONE);
	LCDClear();
	LCDBlOn();
	LCDWriteString(" ForsTest Stend");
	Wait(5);
}

void Wait(uint8_t n)
{
	uint8_t i;
	for(i=0;i<n;i++)
		_delay_loop_2(0);
}

void PumpOn(void)
{
	PUMP_PORT|=(1<<PUMP_PIN);
}


void PumpOff(void)
{
	PUMP_PORT&=(~(1<<PUMP_PIN));
}

void ForsOneOn(void)
{
	FORS_ONE_PORT|=(1<<FORS_ONE_PIN);
}

void ForsOneOff(void)
{
	FORS_ONE_PORT&=(~(1<<FORS_ONE_PIN));
}

void ForsTwoOn(void)
{
	FORS_TWO_PORT|=(1<<FORS_TWO_PIN);
}

void ForsTwoOff(void)
{
	FORS_TWO_PORT&=(~(1<<FORS_TWO_PIN));
}

void ForsThreOn(void)
{
	FORS_THRE_PORT|=(1<<FORS_THRE_PIN);
}

void ForsThreOff(void)
{
	FORS_THRE_PORT&=(~(1<<FORS_THRE_PIN));
}

void ForsFourOn(void)
{
	FORS_FOUR_PORT|=(1<<FORS_FOUR_PIN);
}

void ForsFourOff(void)
{
	FORS_FOUR_PORT&=(~(1<<FORS_FOUR_PIN));
}

void AllForsOn(void)
{
	ForsOneOn();
	ForsTwoOn();
	ForsThreOn();
	ForsFourOn();
}

void AllForsOff(void)
{
	ForsOneOff();
	ForsTwoOff();
	ForsThreOff();
	ForsFourOff();
}

void ValveOn(void)
{
	DRAIN_VALVE_PORT|=(1<<DRAIN_VALVE_PIN);
}

void ValveOff(void)
{
	DRAIN_VALVE_PORT&=(~(1<<DRAIN_VALVE_PIN));
}
